# Uppsala University - Algorithms and Data Structures 1, 1DL210
# Copyright (c) 2020 Henrik Alfken(Schulze), Neethu Joseph,
#               Hooman Asadian, Sarbojit Das
# Assignment 3 - Hash Tables and Binary Search Trees
# Name 1: Neethu Joseph
# Name 2: Henrik Schulze
# ass3bst-demo.py
from ass3bst import *

def printTree(t,tname):
    print(tname+" = ", end='')
    print(t)

def printInorder(t,tname):
    print(" inorder walk of "+tname+": ", end='')
    inorderwalk(t)

def printMin(t,tname):
    print(" minimum of "+tname+": "+str(minimum(t)))

def deleteKeyAndPrintTree(t,tname,key):
    print("Delete "+str(key)+" from "+tname+", and then print "+tname+":")
    t = delete(t, key)
    printTree(t,tname)

def deleteKeyAndPrintInorder(t,tname,key):
    print("Delete "+str(key)+" from "+tname+" & inorder print "+tname+":")
    t = delete(t, key)
    printInorder(t,tname)

print("  -     -     -     -     -")
t1 = insert(emptytree(), 1)
deleteKeyAndPrintTree(t1,"t1",5)
deleteKeyAndPrintTree(t1,"t1",1)

print("  -     -     -     -     -")
t2 = treefromlist([2,6,7,4,1])
printMin(t2,"t2")
deleteKeyAndPrintTree(t2,"t2",6)
printMin(t2,"t2")

print("  -     -     -     -     -")
t3 = treefromlist([10,3,5,1])
deleteKeyAndPrintTree(t3,"t3",1)

print("  -     -     -     -     -")
t4 = treefromlist([3,5])
printTree(t4,"t4")
deleteKeyAndPrintTree(t4,"t4",3)

print("  -     -     -     -     -")
t5 = treefromlist([3,1])
printTree(t5,"t5")
deleteKeyAndPrintTree(t5,"t5",3)

print("  -     -     -     -     -")
t6 = treefromlist([3,5,1])
printTree(t6,"t6")
deleteKeyAndPrintTree(t6,"t6",1)

print("  -     -     -     -     -")
t7 = treefromlist([3,5,1])
printTree(t7,"t7")
deleteKeyAndPrintTree(t7,"t7",3)

print("  -     -     -     -     -")
t8 = treefromlist([2,0,6,1,4,8,3,5,7,9])
printInorder(t8,"t8")
deleteKeyAndPrintInorder(t8,"t8",2)
